qBE3 <-
function(p, mu = 0.5, alpha = 1, beta = 1, tau=0.5, log.p = FALSE)
{
if (is.null(p)) 
        stop("p must be specified")
    if (any(is.null(c(mu, alpha, beta, tau)))) 
        stop("mu, alpha, beta and tau must be specified")
    if (any(tau<=0) | any(tau >= 1)) 
        stop("tau must be between 0 and 1")
    if (any(mu <= 0)) 
        stop("mu must be positive")
    if (any(alpha <= 0)) 
        stop("alpha must be positive")
    if (any(beta <= 0)) 
        stop("beta must be positive")
z=qbeta(tau, shape1=alpha,shape2=beta)
lambda<-(1-mu)*z/(mu*(1-z))
z2=qbeta(p, shape1=alpha,shape2=beta)
z2/(lambda*(1-z2)+z2)
}
